#ifndef __XC8P8508_H__
#define __XC8P8508_H__

//
// Register addresses.
//
//RPAGE Bank0
#define IAR_ADDR         	0X00
#define TCC_ADDR         	0X01
#define PCL_ADDR          	0X02
#define STATUS_ADDR         0X03
#define RSR_ADDR         	0X04
#define PORT5_ADDR        	0X05
#define PORT6_ADDR        	0X06
#define PORT7_ADDR        	0X07
#define LVDCON_ADDR        	0X08
#define P5ICECR_ADDR        0X0C
#define P6ICECR_ADDR        0X0D
#define CPUCON_ADDR        	0X0E
#define ISR_ADDR        	0X0F

#define PWM0CON_ADDR		0X70
#define PWM1CON_ADDR		0X71
#define PWM2CON_ADDR		0X72
#define PWM3CON_ADDR		0X73
#define PWM4CON_ADDR		0X74
#define P5HDCR_ADDR			0X75
#define P5HSCR_ADDR			0X76
#define P6HDCR_ADDR			0X77
#define P6HSCR_ADDR			0X78
#define P5WDCR_ADDR			0X79
#define P5WSCR_ADDR			0X7A
#define DEADCON_ADDR		0X7B
#define DEADTR_ADDR			0X7C
//
//----- Register Files -----------------------------------------------------
//
extern __sfr __at (IAR_ADDR)        	IAR;         	
extern __sfr __at (TCC_ADDR)        	TCC;         	
extern __sfr __at (PCL_ADDR)        	PCL;          	
extern __sfr __at (STATUS_ADDR)        	STATUS;         	
extern __sfr __at (RSR_ADDR)        	RSR;
extern __sfr __at (PORT5_ADDR)        	PORT5;         	
extern __sfr __at (PORT6_ADDR)        	PORT6;
extern __sfr __at (PORT7_ADDR)        	PORT7;         	
extern __sfr __at (LVDCON_ADDR)       	LVDCON;        	        	
extern __sfr __at (P5ICECR_ADDR)       	P5ICECR;        	
extern __sfr __at (P6ICECR_ADDR)       	P6ICECR;        	
extern __sfr __at (CPUCON_ADDR)       	CPUCON;        	
extern __sfr __at (ISR_ADDR)       		ISR;   

extern __sfr __at (PWM0CON_ADDR)        PWM0CON;         	
extern __sfr __at (PWM1CON_ADDR)        PWM1CON;         	
extern __sfr __at (PWM2CON_ADDR)        PWM2CON;          	
extern __sfr __at (PWM3CON_ADDR)        PWM3CON;         	
extern __sfr __at (PWM4CON_ADDR)        PWM4CON;
extern __sfr __at (P5HDCR_ADDR)        	P5HDCR;         	
extern __sfr __at (P5HSCR_ADDR)        	P5HSCR;         	
extern __sfr __at (P6HDCR_ADDR)       	P6HDCR;        	
extern __sfr __at (P6HSCR_ADDR)       	P6HSCR;        	
extern __sfr __at (P5WDCR_ADDR)			P5WDCR;        	
extern __sfr __at (P5WSCR_ADDR)       	P5WSCR;        	
extern __sfr __at (DEADCON_ADDR)       	DEADCON;        	
extern __sfr __at (DEADTR_ADDR)       	DEADTR;              	     	
//==========================================================================
//
//	Configuration Bits
//
//==========================================================================

// ----- IAR Bits --------------------------------------------------------
typedef union {
	struct {
		unsigned char IAR_0:1;
		unsigned char IAR_1:1;
		unsigned char IAR_2:1;
		unsigned char IAR_3:1;	
		unsigned char IAR_4:1;
		unsigned char IAR_5:1;
		unsigned char IAR_6:1;
		unsigned char IAR_7:1;		
	};
} __IARbits_t;
extern volatile __IARbits_t __at(IAR_ADDR) IARbits;

#define IAR_0         	IARbits.IAR_0   	/* bit 0 */
#define IAR_1         	IARbits.IAR_1     	/* bit 1 */
#define IAR_2         	IARbits.IAR_2       /* bit 2 */
#define IAR_3         	IARbits.IAR_3       /* bit 3 */
#define IAR_4         	IARbits.IAR_4   	/* bit 4 */
#define IAR_5         	IARbits.IAR_5     	/* bit 5 */
#define IAR_6         	IARbits.IAR_6       /* bit 6 */
#define IAR_7         	IARbits.IAR_7       /* bit 7 */

// ----- TCC Bits --------------------------------------------------------
typedef union {
	struct {
		unsigned char TCC_0:1;
		unsigned char TCC_1:1;
		unsigned char TCC_2:1;
		unsigned char TCC_3:1;	
		unsigned char TCC_4:1;
		unsigned char TCC_5:1;
		unsigned char TCC_6:1;
		unsigned char TCC_7:1;		
	};
} __TCCbits_t;
extern volatile __TCCbits_t __at(TCC_ADDR) TCCbits;

#define TCC_0         	TCCbits.TCC_0   		/* bit 0 */
#define TCC_1         	TCCbits.TCC_1     		/* bit 1 */
#define TCC_2         	TCCbits.TCC_2       	/* bit 2 */
#define TCC_3         	TCCbits.TCC_3       	/* bit 3 */
#define TCC_4         	TCCbits.TCC_4   		/* bit 4 */
#define TCC_5         	TCCbits.TCC_5     		/* bit 5 */
#define TCC_6         	TCCbits.TCC_6       	/* bit 6 */
#define TCC_7         	TCCbits.TCC_7       	/* bit 7 */

// ----- PCL Bits --------------------------------------------------------
typedef union {
	struct {
		unsigned char PCL_0:1;
		unsigned char PCL_1:1;
		unsigned char PCL_2:1;
		unsigned char PCL_3:1;	
		unsigned char PCL_4:1;
		unsigned char PCL_5:1;
		unsigned char PCL_6:1;
		unsigned char PCL_7:1;		
	};
} __PCLbits_t;
extern volatile __PCLbits_t __at(PCL_ADDR) PCLbits;

#define PCL_0         	PCLbits.PCL_0   		/* bit 0 */
#define PCL_1         	PCLbits.PCL_1     		/* bit 1 */
#define PCL_2         	PCLbits.PCL_2       	/* bit 2 */
#define PCL_3         	PCLbits.PCL_3       	/* bit 3 */
#define PCL_4         	PCLbits.PCL_4   		/* bit 4 */
#define PCL_5         	PCLbits.PCL_5     		/* bit 5 */
#define PCL_6         	PCLbits.PCL_6       	/* bit 6 */
#define PCL_7         	PCLbits.PCL_7       	/* bit 7 */

// ----- STATUS Bits --------------------------------------------------------
typedef union {
	struct {
		unsigned char STATUS_0:1;
		unsigned char STATUS_1:1;
		unsigned char STATUS_2:1;
		unsigned char STATUS_3:1;	
		unsigned char STATUS_4:1;
		unsigned char STATUS_5:1;
		unsigned char STATUS_6:1;
		unsigned char STATUS_7:1;		
	};
} __STATUSbits_t;
extern volatile __STATUSbits_t __at(STATUS_ADDR) STATUSbits;

#define C		STATUSbits.STATUS_0   			/* bit 0 */
#define DC		STATUSbits.STATUS_1				/* bit 1 */
#define Z		STATUSbits.STATUS_2				/* bit 2 */
#define P		STATUSbits.STATUS_3				/* bit 3 */
#define T		STATUSbits.STATUS_4   			/* bit 4 */
#define GP0     STATUSbits.STATUS_5				/* bit 5 */
#define GP1     STATUSbits.STATUS_6				/* bit 6 */
#define WKTP    STATUSbits.STATUS_7				/* bit 7 */

// ----- RSR Bits --------------------------------------------------------
typedef union {
	struct {
		unsigned char RSR_0:1;
		unsigned char RSR_1:1;
		unsigned char RSR_2:1;
		unsigned char RSR_3:1;	
		unsigned char RSR_4:1;
		unsigned char RSR_5:1;
		unsigned char RSR_6:1;
		unsigned char RSR_7:1;		
	};
} __RSRbits_t;
extern volatile __RSRbits_t __at(RSR_ADDR) RSRbits;

#define RSR_0         	RSRbits.RSR_0   	/* bit 0 */
#define RSR_1         	RSRbits.RSR_1    	/* bit 1 */
#define RSR_2         	RSRbits.RSR_2    	/* bit 2 */
#define RSR_3         	RSRbits.RSR_3    	/* bit 3 */
#define RSR_4         	RSRbits.RSR_4   	/* bit 4 */
#define RSR_5         	RSRbits.RSR_5    	/* bit 5 */
#define RSR_6         	RSRbits.RSR_6    	/* bit 6 */
#define RSR_7         	RSRbits.RSR_7    	/* bit 7 */

// ----- PORT5 Bits --------------------------------------------------------
typedef union {
	struct {
		unsigned char PORT5_0:1;
		unsigned char PORT5_1:1;
		unsigned char PORT5_2:1;
		unsigned char PORT5_3:1;	
		unsigned char PORT5_4:1;
		unsigned char PORT5_5:1;
		unsigned char PORT5_6:1;
		unsigned char PORT5_7:1;		
	};
} __PORT5bits_t;
extern volatile __PORT5bits_t __at(PORT5_ADDR) PORT5bits;

#define PORT5_0         PORT5bits.PORT5_0   	/* bit 0 */
#define PORT5_1         PORT5bits.PORT5_1     	/* bit 1 */
#define PORT5_2         PORT5bits.PORT5_2       /* bit 2 */
#define PORT5_3         PORT5bits.PORT5_3       /* bit 3 */
#define PORT5_4         PORT5bits.PORT5_4   	/* bit 4 */
#define PORT5_5         PORT5bits.PORT5_5     	/* bit 5 */
#define PORT5_6         PORT5bits.PORT5_6       /* bit 6 */
#define PORT5_7         PORT5bits.PORT5_7       /* bit 7 */

// ----- PORT6 Bits --------------------------------------------------------
typedef union {
	struct {
		unsigned char PORT6_0:1;
		unsigned char PORT6_1:1;
		unsigned char PORT6_2:1;
		unsigned char PORT6_3:1;	
		unsigned char PORT6_4:1;
		unsigned char PORT6_5:1;
		unsigned char PORT6_6:1;
		unsigned char PORT6_7:1;		
	};
} __PORT6bits_t;
extern volatile __PORT6bits_t __at(PORT6_ADDR) PORT6bits;

#define PORT6_0         PORT6bits.PORT6_0   	/* bit 0 */
#define PORT6_1         PORT6bits.PORT6_1     	/* bit 1 */
#define PORT6_2         PORT6bits.PORT6_2       /* bit 2 */
#define PORT6_3         PORT6bits.PORT6_3       /* bit 3 */
#define PORT6_4         PORT6bits.PORT6_4   	/* bit 4 */
#define PORT6_5         PORT6bits.PORT6_5     	/* bit 5 */
#define PORT6_6         PORT6bits.PORT6_6       /* bit 6 */
#define PORT6_7         PORT6bits.PORT6_7       /* bit 7 */

// ----- PORT7 Bits --------------------------------------------------------
typedef union {
	struct {
		unsigned char PORT7_0:1;
		unsigned char PORT7_1:1;
		unsigned char PORT7_2:1;
		unsigned char PORT7_3:1;	
		unsigned char PORT7_4:1;
		unsigned char PORT7_5:1;
		unsigned char PORT7_6:1;
		unsigned char PORT7_7:1;		
	};
} __PORT7bits_t;
extern volatile __PORT7bits_t __at(PORT7_ADDR) PORT7bits;

#define PORT7_0         PORT7bits.PORT7_0   	/* bit 0 */
#define PORT7_1         PORT7bits.PORT7_1     	/* bit 1 */

// ----- LVDCON Bits --------------------------------------------------------
typedef union {
	struct {
		unsigned char LVDCON_0:1;
		unsigned char LVDCON_1:1;
		unsigned char LVDCON_2:1;
		unsigned char LVDCON_3:1;	
		unsigned char LVDCON_4:1;
		unsigned char LVDCON_5:1;
		unsigned char LVDCON_6:1;
		unsigned char LVDCON_7:1;		
	};
} __LVDCONbits_t;
extern volatile __LVDCONbits_t __at(LVDCON_ADDR) LVDCONbits;

#define LVDSEL0			LVDCONbits.LVDCON_0   	/* bit 0 */
#define LVDSEL1			LVDCONbits.LVDCON_1     /* bit 1 */
#define LVDSEL2			LVDCONbits.LVDCON_2     /* bit 2 */
#define LVDSEL3			LVDCONbits.LVDCON_3     /* bit 3 */
#define LVDSEL4			LVDCONbits.LVDCON_4   	/* bit 4 */
#define EXVEN			LVDCONbits.LVDCON_5     /* bit 5 */
#define VDET			LVDCONbits.LVDCON_6     /* bit 6 */
#define LVDEN			LVDCONbits.LVDCON_7     /* bit 7 */

// ----- P5ICECR Bits --------------------------------------------------------
typedef union {
	struct {
		unsigned char P5ICECR_0:1;
		unsigned char P5ICECR_1:1;
		unsigned char P5ICECR_2:1;
		unsigned char P5ICECR_3:1;	
		unsigned char P5ICECR_4:1;
		unsigned char P5ICECR_5:1;
		unsigned char P5ICECR_6:1;
		unsigned char P5ICECR_7:1;		
	};
} __P5ICECRbits_t;
extern volatile __P5ICECRbits_t __at(P5ICECR_ADDR) P5ICECRbits;

#define P5ICECR0		P5ICECRbits.P5ICECR_0   	/* bit 0 */
#define P5ICECR1		P5ICECRbits.P5ICECR_1     	/* bit 1 */
#define P5ICECR2		P5ICECRbits.P5ICECR_2       /* bit 2 */
#define P5ICECR3		P5ICECRbits.P5ICECR_3       /* bit 3 */
#define P5ICECR4		P5ICECRbits.P5ICECR_4   	/* bit 4 */
#define P5ICECR5		P5ICECRbits.P5ICECR_5     	/* bit 5 */
#define P5ICECR6        P5ICECRbits.P5ICECR_6       /* bit 6 */
#define P5ICECR7        P5ICECRbits.P5ICECR_7       /* bit 7 */

// ----- P6ICECR Bits --------------------------------------------------------
typedef union {
	struct {
		unsigned char P6ICECR_0:1;
		unsigned char P6ICECR_1:1;
		unsigned char P6ICECR_2:1;
		unsigned char P6ICECR_3:1;	
		unsigned char P6ICECR_4:1;
		unsigned char P6ICECR_5:1;
		unsigned char P6ICECR_6:1;
		unsigned char P6ICECR_7:1;		
	};
} __P6ICECRbits_t;
extern volatile __P6ICECRbits_t __at(P6ICECR_ADDR) P6ICECRbits;

#define P6ICECR0		P6ICECRbits.P6ICECR_0   	/* bit 0 */
#define P6ICECR1		P6ICECRbits.P6ICECR_1     	/* bit 1 */
#define P6ICECR2		P6ICECRbits.P6ICECR_2       /* bit 2 */
#define P6ICECR3		P6ICECRbits.P6ICECR_3       /* bit 3 */
#define P6ICECR4		P6ICECRbits.P6ICECR_4   	/* bit 4 */
#define P6ICECR5		P6ICECRbits.P6ICECR_5     	/* bit 5 */
#define P6ICECR6        P6ICECRbits.P6ICECR_6       /* bit 6 */
#define P6ICECR7        P6ICECRbits.P6ICECR_7       /* bit 7 */

// ----- CPUCON Bits --------------------------------------------------------
typedef union {
	struct {
		unsigned char CPUCON_0:1;
		unsigned char CPUCON_1:1;
		unsigned char CPUCON_2:1;
		unsigned char CPUCON_3:1;	
		unsigned char CPUCON_4:1;
		unsigned char CPUCON_5:1;
		unsigned char CPUCON_6:1;
		unsigned char CPUCON_7:1;		
	};
} __CPUCONbits_t;
extern volatile __CPUCONbits_t __at(CPUCON_ADDR) CPUCONbits;

#define IDLE			CPUCONbits.CPUCON_0   		/* bit 0 */
#define CLKMD			CPUCONbits.CPUCON_1    		/* bit 1 */
#define STPHX	        CPUCONbits.CPUCON_2    		/* bit 2 */
#define TCCWE			CPUCONbits.CPUCON_3    		/* bit 3 */
#define PWMWE			CPUCONbits.CPUCON_4   		/* bit 4 */
#define TCCCKS			CPUCONbits.CPUCON_5    		/* bit 5 */
#define TxEN			CPUCONbits.CPUCON_6    		/* bit 6 */

// ----- ISR Bits --------------------------------------------------------
typedef union {
	struct {
		unsigned char ISR_0:1;
		unsigned char ISR_1:1;
		unsigned char ISR_2:1;
		unsigned char ISR_3:1;	
		unsigned char ISR_4:1;
		unsigned char ISR_5:1;
		unsigned char ISR_6:1;
		unsigned char ISR_7:1;		
	};
} __ISRbits_t;
extern volatile __ISRbits_t __at(ISR_ADDR) ISRbits;

#define TCIF         	ISRbits.ISR_0   		/* bit 0 */
#define P6ICIF         	ISRbits.ISR_1     		/* bit 1 */
#define EXIF         	ISRbits.ISR_2          	/* bit 2 */
#define P5ICIF         	ISRbits.ISR_3          	/* bit 3 */
#define LVDIF         	ISRbits.ISR_4   		/* bit 4 */
#define PWM0IF         	ISRbits.ISR_5     		/* bit 5 */
#define PWM1IF         	ISRbits.ISR_6          	/* bit 6 */
#define PWM2IF         	ISRbits.ISR_7          	/* bit 7 */

// ----- PWM0CON Bits --------------------------------------------------------
typedef union {
	struct {
		unsigned char PWM0CON_0:1;
		unsigned char PWM0CON_1:1;
		unsigned char PWM0CON_2:1;
		unsigned char PWM0CON_3:1;	
		unsigned char PWM0CON_4:1;
		unsigned char PWM0CON_5:1;
		unsigned char PWM0CON_6:1;
		unsigned char PWM0CON_7:1;		
	};
} __PWM0CONbits_t;
extern volatile __PWM0CONbits_t __at(PWM0CON_ADDR) PWM0CONbits;

#define T0PSR0         	PWM0CONbits.PWM0CON_0   	/* bit 0 */
#define T0PSR1         	PWM0CONbits.PWM0CON_1     	/* bit 1 */
#define T0PSR2         	PWM0CONbits.PWM0CON_2       /* bit 2 */
#define T0PTEN         	PWM0CONbits.PWM0CON_3       /* bit 3 */
#define PWM0CKS         PWM0CONbits.PWM0CON_4		/* bit 4 */
#define PWM0EN         	PWM0CONbits.PWM0CON_5     	/* bit 5 */
#define IPWM0EN         PWM0CONbits.PWM0CON_6       /* bit 6 */
#define T0EN         	PWM0CONbits.PWM0CON_7       /* bit 7 */

// ----- PWM1CON Bits --------------------------------------------------------
typedef union {
	struct {
		unsigned char PWM1CON_0:1;
		unsigned char PWM1CON_1:1;
		unsigned char PWM1CON_2:1;
		unsigned char PWM1CON_3:1;	
		unsigned char PWM1CON_4:1;
		unsigned char PWM1CON_5:1;
		unsigned char PWM1CON_6:1;
		unsigned char PWM1CON_7:1;		
	};
} __PWM1CONbits_t;
extern volatile __PWM1CONbits_t __at(PWM1CON_ADDR) PWM1CONbits;

#define T1PSR0         	PWM1CONbits.PWM1CON_0   	/* bit 0 */
#define T1PSR1         	PWM1CONbits.PWM1CON_1     	/* bit 1 */
#define T1PSR2         	PWM1CONbits.PWM1CON_2       /* bit 2 */
#define T1PTEN         	PWM1CONbits.PWM1CON_3       /* bit 3 */
#define PWM1CKS         PWM1CONbits.PWM1CON_4   	/* bit 4 */
#define PWM1EN         	PWM1CONbits.PWM1CON_5     	/* bit 5 */
#define IPWM1EN         PWM1CONbits.PWM1CON_6       /* bit 6 */
#define T1EN         	PWM1CONbits.PWM1CON_7       /* bit 7 */

// ----- PWM2CON Bits --------------------------------------------------------
typedef union {
	struct {
		unsigned char PWM2CON_0:1;
		unsigned char PWM2CON_1:1;
		unsigned char PWM2CON_2:1;
		unsigned char PWM2CON_3:1;	
		unsigned char PWM2CON_4:1;
		unsigned char PWM2CON_5:1;
		unsigned char PWM2CON_6:1;
		unsigned char PWM2CON_7:1;		
	};
} __PWM2CONbits_t;
extern volatile __PWM2CONbits_t __at(PWM2CON_ADDR) PWM2CONbits;

#define T2PSR0         	PWM2CONbits.PWM2CON_0   	/* bit 0 */
#define T2PSR1         	PWM2CONbits.PWM2CON_1     	/* bit 1 */
#define T2PSR2         	PWM2CONbits.PWM2CON_2       /* bit 2 */
#define T2PTEN         	PWM2CONbits.PWM2CON_3       /* bit 3 */
#define PWM2CKS         PWM2CONbits.PWM2CON_4		/* bit 4 */
#define PWM2EN         	PWM2CONbits.PWM2CON_5     	/* bit 5 */
#define IPWM2EN         PWM2CONbits.PWM2CON_6       /* bit 6 */
#define T2EN         	PWM2CONbits.PWM2CON_7       /* bit 7 */

// ----- PWM3CON Bits --------------------------------------------------------
typedef union {
	struct {
		unsigned char PWM3CON_0:1;
		unsigned char PWM3CON_1:1;
		unsigned char PWM3CON_2:1;
		unsigned char PWM3CON_3:1;	
		unsigned char PWM3CON_4:1;
		unsigned char PWM3CON_5:1;
		unsigned char PWM3CON_6:1;
		unsigned char PWM3CON_7:1;		
	};
} __PWM3CONbits_t;
extern volatile __PWM3CONbits_t __at(PWM3CON_ADDR) PWM3CONbits;

#define T3PSR0         	PWM3CONbits.PWM3CON_0   	/* bit 0 */
#define T3PSR1         	PWM3CONbits.PWM3CON_1     	/* bit 1 */
#define T3PSR2         	PWM3CONbits.PWM3CON_2       /* bit 2 */
#define T3PTEN         	PWM3CONbits.PWM3CON_3       /* bit 3 */
#define PWM3CKS         PWM3CONbits.PWM3CON_4		/* bit 4 */
#define PWM3EN         	PWM3CONbits.PWM3CON_5     	/* bit 5 */
#define IPWM3EN         PWM3CONbits.PWM3CON_6       /* bit 6 */
#define T3EN         	PWM3CONbits.PWM3CON_7       /* bit 7 */

// ----- PWM4CON Bits --------------------------------------------------------
typedef union {
	struct {
		unsigned char PWM4CON_0:1;
		unsigned char PWM4CON_1:1;
		unsigned char PWM4CON_2:1;
		unsigned char PWM4CON_3:1;	
		unsigned char PWM4CON_4:1;
		unsigned char PWM4CON_5:1;
		unsigned char PWM4CON_6:1;
		unsigned char PWM4CON_7:1;		
	};
} __PWM4CONbits_t;
extern volatile __PWM4CONbits_t __at(PWM4CON_ADDR) PWM4CONbits;

#define T4PSR0         	PWM4CONbits.PWM4CON_0   		/* bit 0 */
#define T4PSR1         	PWM4CONbits.PWM4CON_1     		/* bit 1 */
#define T4PSR2         	PWM4CONbits.PWM4CON_2          	/* bit 2 */
#define T4PTEN         	PWM4CONbits.PWM4CON_3          	/* bit 3 */
#define PWM4CKS         PWM4CONbits.PWM4CON_4   		/* bit 4 */
#define PWM4EN         	PWM4CONbits.PWM4CON_5     		/* bit 5 */
#define IPWM4EN         PWM4CONbits.PWM4CON_6          	/* bit 6 */
#define T4EN         	PWM4CONbits.PWM4CON_7          	/* bit 7 */

// ----- P5HDCR Bits --------------------------------------------------------
typedef union {
	struct {
		unsigned char P5HDCR_0:1;
		unsigned char P5HDCR_1:1;
		unsigned char P5HDCR_2:1;
		unsigned char P5HDCR_3:1;	
		unsigned char P5HDCR_4:1;
		unsigned char P5HDCR_5:1;
		unsigned char P5HDCR_6:1;
		unsigned char P5HDCR_7:1;		
	};
} __P5HDCRbits_t;
extern volatile __P5HDCRbits_t __at(P5HDCR_ADDR) P5HDCRbits;

#define P5HD0         	P5HDCRbits.P5HDCR_0   			/* bit 0 */
#define P5HD1         	P5HDCRbits.P5HDCR_1     		/* bit 1 */
#define P5HD2         	P5HDCRbits.P5HDCR_2          	/* bit 2 */
#define P5HD3         	P5HDCRbits.P5HDCR_3          	/* bit 3 */
#define P5HD4         	P5HDCRbits.P5HDCR_4   			/* bit 4 */
#define P5HD5         	P5HDCRbits.P5HDCR_5     		/* bit 5 */
#define P5HD6         	P5HDCRbits.P5HDCR_6          	/* bit 6 */
#define P5HD7         	P5HDCRbits.P5HDCR_7          	/* bit 7 */

// ----- P5HSCR Bits --------------------------------------------------------
typedef union {
	struct {
		unsigned char P5HSCR_0:1;
		unsigned char P5HSCR_1:1;
		unsigned char P5HSCR_2:1;
		unsigned char P5HSCR_3:1;	
		unsigned char P5HSCR_4:1;
		unsigned char P5HSCR_5:1;
		unsigned char P5HSCR_6:1;
		unsigned char P5HSCR_7:1;		
	};
} __P5HSCRbits_t;
extern volatile __P5HSCRbits_t __at(P5HSCR_ADDR) P5HSCRbits;

#define P5HS0         	P5HSCRbits.P5HSCR_0   			/* bit 0 */
#define P5HS1         	P5HSCRbits.P5HSCR_1     		/* bit 1 */
#define P5HS2         	P5HSCRbits.P5HSCR_2          	/* bit 2 */
#define P5HS3         	P5HSCRbits.P5HSCR_3          	/* bit 3 */
#define P5HS4         	P5HSCRbits.P5HSCR_4   			/* bit 4 */
#define P5HS5         	P5HSCRbits.P5HSCR_5     		/* bit 5 */
#define P5HS6         	P5HSCRbits.P5HSCR_6          	/* bit 6 */
#define P5HS7         	P5HSCRbits.P5HSCR_7          	/* bit 7 */

// ----- P6HDCR Bits --------------------------------------------------------
typedef union {
	struct {
		unsigned char P6HDCR_0:1;
		unsigned char P6HDCR_1:1;
		unsigned char P6HDCR_2:1;
		unsigned char P6HDCR_3:1;	
		unsigned char P6HDCR_4:1;
		unsigned char P6HDCR_5:1;
		unsigned char P6HDCR_6:1;
		unsigned char P6HDCR_7:1;		
	};
} __P6HDCRbits_t;
extern volatile __P6HDCRbits_t __at(P6HDCR_ADDR) P6HDCRbits;

#define P6HD0         	P6HDCRbits.P6HDCR_0   			/* bit 0 */
#define P6HD1         	P6HDCRbits.P6HDCR_1     		/* bit 1 */
#define P6HD2         	P6HDCRbits.P6HDCR_2          	/* bit 2 */
#define P6HD3         	P6HDCRbits.P6HDCR_3          	/* bit 3 */
#define P6HD4         	P6HDCRbits.P6HDCR_4   			/* bit 4 */
#define P6HD5         	P6HDCRbits.P6HDCR_5     		/* bit 5 */
#define P6HD6         	P6HDCRbits.P6HDCR_6          	/* bit 6 */
#define P6HD7         	P6HDCRbits.P6HDCR_7          	/* bit 7 */

// ----- P6HSCR Bits --------------------------------------------------------
typedef union {
	struct {
		unsigned char P6HSCR_0:1;
		unsigned char P6HSCR_1:1;
		unsigned char P6HSCR_2:1;
		unsigned char P6HSCR_3:1;	
		unsigned char P6HSCR_4:1;
		unsigned char P6HSCR_5:1;
		unsigned char P6HSCR_6:1;
		unsigned char P6HSCR_7:1;		
	};
} __P6HSCRbits_t;
extern volatile __P6HSCRbits_t __at(P6HSCR_ADDR) P6HSCRbits;

#define P6HS0         	P6HSCRbits.P6HSCR_0   			/* bit 0 */
#define P6HS1         	P6HSCRbits.P6HSCR_1     		/* bit 1 */
#define P6HS2         	P6HSCRbits.P6HSCR_2          	/* bit 2 */
#define P6HS3         	P6HSCRbits.P6HSCR_3          	/* bit 3 */
#define P6HS4         	P6HSCRbits.P6HSCR_4   			/* bit 4 */
#define P6HS5         	P6HSCRbits.P6HSCR_5     		/* bit 5 */
#define P6HS6         	P6HSCRbits.P6HSCR_6          	/* bit 6 */
#define P6HS7         	P6HSCRbits.P6HSCR_7          	/* bit 7 */

// ----- P5WDCR Bits --------------------------------------------------------
typedef union {
	struct {
		unsigned char P5WDCR_0:1;
		unsigned char P5WDCR_1:1;
		unsigned char P5WDCR_2:1;
		unsigned char P5WDCR_3:1;	
		unsigned char P5WDCR_4:1;
		unsigned char P5WDCR_5:1;
		unsigned char P5WDCR_6:1;
		unsigned char P5WDCR_7:1;		
	};
} __P5WDCRbits_t;
extern volatile __P5WDCRbits_t __at(P5WDCR_ADDR) P5WDCRbits;

#define P5WD0         	P5WDCRbits.P5WDCR_0   			/* bit 0 */
#define P5WD1         	P5WDCRbits.P5WDCR_1     		/* bit 1 */
#define P5WD2         	P5WDCRbits.P5WDCR_2          	/* bit 2 */
#define P5WD3         	P5WDCRbits.P5WDCR_3          	/* bit 3 */
#define P5WD4         	P5WDCRbits.P5WDCR_4   			/* bit 4 */
#define P5WD5         	P5WDCRbits.P5WDCR_5     		/* bit 5 */
#define P5WD6         	P5WDCRbits.P5WDCR_6          	/* bit 6 */
#define P5WD7         	P5WDCRbits.P5WDCR_7          	/* bit 7 */

// ----- P5WSCR Bits --------------------------------------------------------
typedef union {
	struct {
		unsigned char P5WSCR_0:1;
		unsigned char P5WSCR_1:1;
		unsigned char P5WSCR_2:1;
		unsigned char P5WSCR_3:1;	
		unsigned char P5WSCR_4:1;
		unsigned char P5WSCR_5:1;
		unsigned char P5WSCR_6:1;
		unsigned char P5WSCR_7:1;		
	};
} __P5WSCRbits_t;
extern volatile __P5WSCRbits_t __at(P5WSCR_ADDR) P5WSCRbits;

#define P5WS0         	P5WSCRbits.P5WSCR_0   			/* bit 0 */
#define P5WS1         	P5WSCRbits.P5WSCR_1     		/* bit 1 */
#define P5WS2         	P5WSCRbits.P5WSCR_2          	/* bit 2 */
#define P5WS3         	P5WSCRbits.P5WSCR_3          	/* bit 3 */
#define P5WS4         	P5WSCRbits.P5WSCR_4   			/* bit 4 */
#define P5WS5         	P5WSCRbits.P5WSCR_5     		/* bit 5 */
#define P5WS6         	P5WSCRbits.P5WSCR_6          	/* bit 6 */
#define P5WS7         	P5WSCRbits.P5WSCR_7          	/* bit 7 */

// ----- DEADCON Bits --------------------------------------------------------
typedef union {
	struct {
		unsigned char DEADCON_0:1;
		unsigned char DEADCON_1:1;
		unsigned char DEADCON_2:1;
		unsigned char DEADCON_3:1;	
		unsigned char DEADCON_4:1;
		unsigned char DEADCON_5:1;
		unsigned char DEADCON_6:1;
		unsigned char DEADCON_7:1;		
	};
} __DEADCONbits_t;
extern volatile __DEADCONbits_t __at(DEADCON_ADDR) DEADCONbits;

#define DEADP0         	DEADCONbits.DEADCON_0   		/* bit 0 */
#define DEADP1         	DEADCONbits.DEADCON_1     		/* bit 1 */
#define DEADP2         	DEADCONbits.DEADCON_2          	/* bit 2 */
#define DEADCKS         DEADCONbits.DEADCON_3          	/* bit 3 */
#define DEADE0         	DEADCONbits.DEADCON_4   		/* bit 4 */
#define DEADE1         	DEADCONbits.DEADCON_5     		/* bit 5 */
#define DEADE2         	DEADCONbits.DEADCON_6          	/* bit 6 */
#define DEADE3         	DEADCONbits.DEADCON_7          	/* bit 7 */

// ----- DEADTR Bits --------------------------------------------------------
typedef union {
	struct {
		unsigned char DEADTR_0:1;
		unsigned char DEADTR_1:1;
		unsigned char DEADTR_2:1;
		unsigned char DEADTR_3:1;	
		unsigned char DEADTR_4:1;
		unsigned char DEADTR_5:1;
		unsigned char DEADTR_6:1;
		unsigned char DEADTR_7:1;		
	};
} __DEADTRbits_t;
extern volatile __DEADTRbits_t __at(DEADTR_ADDR) DEADTRbits;

#define DEADTR_0         DEADTRbits.DEADTR_0   			/* bit 0 */
#define DEADTR_1         DEADTRbits.DEADTR_1     		/* bit 1 */
#define DEADTR_2         DEADTRbits.DEADTR_2          	/* bit 2 */
#define DEADTR_3         DEADTRbits.DEADTR_3          	/* bit 3 */
#define DEADTR_4         DEADTRbits.DEADTR_4   			/* bit 4 */
#define DEADTR_5         DEADTRbits.DEADTR_5     		/* bit 5 */
#define DEADTR_6         DEADTRbits.DEADTR_6          	/* bit 6 */
#define DEADTR_7         DEADTRbits.DEADTR_7          	/* bit 7 */

#endif